package jp.co.konica.mg.webdb;


import java.math.BigDecimal;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.Date;
import java.util.Collections;
import java.util.List;

import org.apache.commons.lang.ObjectUtils;
import org.apache.torque.TorqueException;
import org.apache.torque.om.BaseObject;
import org.apache.torque.om.ComboKey;
import org.apache.torque.om.DateKey;
import org.apache.torque.om.NumberKey;
import org.apache.torque.om.ObjectKey;
import org.apache.torque.om.SimpleKey;
import org.apache.torque.om.StringKey;
import org.apache.torque.om.Persistent;
import org.apache.torque.util.Criteria;
import org.apache.torque.util.Transaction;


/**
 * This class was autogenerated by Torque on:
 *
 * [Tue Sep 02 21:52:53 JST 2003]
 *
 * You should not use this class directly.  It should not even be
 * extended all references should be to Patient
 */
public abstract class BasePatient extends BaseObject
{
    /** The Peer class */
    private static final PatientPeer peer =
        new PatientPeer();

                  
        /**
         * The value for the patient_id field
         */
        private int patient_id;
              
        /**
         * The value for the patient_name field
         */
        private String patient_name;
              
        /**
         * The value for the patient_age field
         */
        private int patient_age;
              
        /**
         * The value for the patient_sex field
         */
        private String patient_sex;
      
      
        /**
         * Get the PatientId
         *
         * @return int
         */
        public int getPatientId()
        {
            return patient_id;
        }

                                                                              
        /**
         * Set the value of PatientId
         *
         * @param v new value
         */
        public void setPatientId(int v) throws TorqueException
        {
          


         if (this.patient_id != v)
        {
             this.patient_id = v;
            setModified(true);
        }

                  
                                                  
              // update associated Ordering
              if (collOrderings != null)
              {
                  for (int i = 0; i < collOrderings.size(); i++)
                  {
                      ((Ordering) collOrderings.get(i))
                          .setPatientId(v);
                  }
              }
                                   }


        /**
         * Get the PatientName
         *
         * @return String
         */
        public String getPatientName()
        {
            return patient_name;
        }

                                            
        /**
         * Set the value of PatientName
         *
         * @param v new value
         */
        public void setPatientName(String v) 
        {
          


         if (!ObjectUtils.equals(this.patient_name, v))
        {
             this.patient_name = v;
            setModified(true);
        }

                  
                       }


        /**
         * Get the PatientAge
         *
         * @return int
         */
        public int getPatientAge()
        {
            return patient_age;
        }

                                            
        /**
         * Set the value of PatientAge
         *
         * @param v new value
         */
        public void setPatientAge(int v) 
        {
          


         if (this.patient_age != v)
        {
             this.patient_age = v;
            setModified(true);
        }

                  
                       }


        /**
         * Get the PatientSex
         *
         * @return String
         */
        public String getPatientSex()
        {
            return patient_sex;
        }

                                            
        /**
         * Set the value of PatientSex
         *
         * @param v new value
         */
        public void setPatientSex(String v) 
        {
          


         if (!ObjectUtils.equals(this.patient_sex, v))
        {
             this.patient_sex = v;
            setModified(true);
        }

                  
                       }


 
        
                
      
    /**
     * Collection to store aggregation of collOrderings
     */
    protected List collOrderings;

    /**
     * Temporary storage of collOrderings to save a possible db hit in
     * the event objects are add to the collection, but the
     * complete collection is never requested.
     */
    protected void initOrderings()
    {
        if (collOrderings == null)
        {
            collOrderings = new ArrayList();
        }
    }

    /**
     * Method called to associate a Ordering object to this object
     * through the Ordering foreign key attribute
     *
     * @param l Ordering
     * @throws TorqueException
     */
    public void addOrdering(Ordering l) throws TorqueException
    {
        getOrderings().add(l);
        l.setPatient((Patient) this);
    }

    /**
     * The criteria used to select the current contents of collOrderings
     */
    private Criteria lastOrderingsCriteria = null;

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getOrderings(new Criteria())
     *
     * @throws TorqueException
     */
    public List getOrderings() throws TorqueException
    {
        if (collOrderings == null)
        {
            collOrderings = getOrderings(new Criteria(10));
        }
        return collOrderings;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Patient has previously
     * been saved, it will retrieve related Orderings from storage.
     * If this Patient is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     *
     * @throws TorqueException
     */
    public List getOrderings(Criteria criteria) throws TorqueException
    {
        if (collOrderings == null)
        {
            if (isNew())
            {
               collOrderings = new ArrayList();
            }
            else
            {
                   criteria.add(OrderingPeer.PATIENT_ID, getPatientId() );
                   collOrderings = OrderingPeer.doSelect(criteria);
            }
        }
        else
        {
            // criteria has no effect for a new object
            if (!isNew())
            {
                // the following code is to determine if a new query is
                // called for.  If the criteria is the same as the last
                // one, just return the collection.
                   criteria.add(OrderingPeer.PATIENT_ID, getPatientId());
                   if (!lastOrderingsCriteria.equals(criteria))
                {
                    collOrderings = OrderingPeer.doSelect(criteria);
                }
            }
        }
        lastOrderingsCriteria = criteria;

        return collOrderings;
    }

    /**
     * If this collection has already been initialized, returns
     * the collection. Otherwise returns the results of
     * getOrderings(new Criteria(),Connection)
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getOrderings(Connection con) throws TorqueException
    {
        if (collOrderings == null)
        {
            collOrderings = getOrderings(new Criteria(10), con);
        }
        return collOrderings;
    }

    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Patient has previously
     * been saved, it will retrieve related Orderings from storage.
     * If this Patient is new, it will return
     * an empty collection or the current collection, the criteria
     * is ignored on a new object.
     * This method takes in the Connection also as input so that
     * referenced objects can also be obtained using a Connection
     * that is taken as input
     */
    public List getOrderings(Criteria criteria, Connection con)
            throws TorqueException
    {
        if (collOrderings == null)
        {
            if (isNew())
            {
               collOrderings = new ArrayList();
            }
            else
            {
                     criteria.add(OrderingPeer.PATIENT_ID, getPatientId());
                     collOrderings = OrderingPeer.doSelect(criteria, con);
             }
         }
         else
         {
             // criteria has no effect for a new object
             if (!isNew())
             {
                 // the following code is to determine if a new query is
                 // called for.  If the criteria is the same as the last
                 // one, just return the collection.
                     criteria.add(OrderingPeer.PATIENT_ID, getPatientId());
                     if (!lastOrderingsCriteria.equals(criteria))
                 {
                     collOrderings = OrderingPeer.doSelect(criteria, con);
                 }
             }
         }
         lastOrderingsCriteria = criteria;

         return collOrderings;
     }

   

     
      
         
          
                            
                
        
        
   
    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Patient is new, it will return
     * an empty collection; or if this Patient has previously
     * been saved, it will retrieve related Orderings from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Patient.
     */
    protected List getOrderingsJoinPatient(Criteria criteria)
        throws TorqueException
    {
        if (collOrderings == null)
        {
            if (isNew())
            {
               collOrderings = new ArrayList();
            }
            else
            {
                   criteria.add(OrderingPeer.PATIENT_ID, getPatientId());
                   collOrderings = OrderingPeer.doSelectJoinPatient(criteria);
            }
        }
        else
        {
            // the following code is to determine if a new query is
            // called for.  If the criteria is the same as the last
            // one, just return the collection.
            boolean newCriteria = true;
                   criteria.add(OrderingPeer.PATIENT_ID, getPatientId());
               if (!lastOrderingsCriteria.equals(criteria))
            {
                collOrderings = OrderingPeer.doSelectJoinPatient(criteria);
            }
        }
        lastOrderingsCriteria = criteria;

        return collOrderings;
    }
     



     
    
    private static List fieldNames = null;

    /**
     * Generate a list of field names.
     *
     * @return a list of field names
     */
    public static synchronized List getFieldNames()
    {
      if (fieldNames == null)
      {
        fieldNames = new ArrayList();
            fieldNames.add("PatientId");
            fieldNames.add("PatientName");
            fieldNames.add("PatientAge");
            fieldNames.add("PatientSex");
            fieldNames = Collections.unmodifiableList(fieldNames);
      }
      return fieldNames;
    }

    /**
     * Retrieves a field from the object by name passed in as a String.
     *
     * @param name field name
     * @return value
     */
    public Object getByName(String name)
    {
            if (name.equals("PatientId"))
    {
              return new Integer(getPatientId());
          }
            if (name.equals("PatientName"))
    {
              return getPatientName();
          }
            if (name.equals("PatientAge"))
    {
              return new Integer(getPatientAge());
          }
            if (name.equals("PatientSex"))
    {
              return getPatientSex();
          }
            return null;
    }
    /**
     * Retrieves a field from the object by name passed in
     * as a String.  The String must be one of the static
     * Strings defined in this Class' Peer.
     *
     * @param name peer name
     * @return value
     */
    public Object getByPeerName(String name)
    {
            if (name.equals(PatientPeer.PATIENT_ID))
        {
              return new Integer(getPatientId());
          }
            if (name.equals(PatientPeer.PATIENT_NAME))
        {
              return getPatientName();
          }
            if (name.equals(PatientPeer.PATIENT_AGE))
        {
              return new Integer(getPatientAge());
          }
            if (name.equals(PatientPeer.PATIENT_SEX))
        {
              return getPatientSex();
          }
            return null;
    }

    /**
     * Retrieves a field from the object by Position as specified
     * in the xml schema.  Zero-based.
     *
     * @param pos position in xml schema
     * @return value
     */
    public Object getByPosition(int pos)
    {
            if (pos == 0)
    {
              return new Integer(getPatientId());
          }
            if (pos == 1)
    {
              return getPatientName();
          }
            if (pos == 2)
    {
              return new Integer(getPatientAge());
          }
            if (pos == 3)
    {
              return getPatientSex();
          }
                return null;
    }

     


    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     *
     * @throws Exception
     */
    public void save() throws Exception
    {
             save(PatientPeer.getMapBuilder()
                .getDatabaseMap().getName());
     }

    /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.
     * Note: this code is here because the method body is
     * auto-generated conditionally and therefore needs to be
     * in this file instead of in the super class, BaseObject.
     *
     * @param dbName
     * @throws TorqueException
     */
    public void save(String dbName) throws TorqueException
    {
        Connection con = null;
         try
        {
            con = Transaction.begin(dbName);
            save(con);
            Transaction.commit(con);
        }
        catch(TorqueException e)
        {
            Transaction.safeRollback(con);
            throw e;
        }

     }

      /** flag to prevent endless save loop, if this object is referenced
        by another object which falls in this transaction. */
    private boolean alreadyInSave = false;
      /**
     * Stores the object in the database.  If the object is new,
     * it inserts it; otherwise an update is performed.  This method
     * is meant to be used as part of a transaction, otherwise use
     * the save() method and the connection details will be handled
     * internally
     *
     * @param con
     * @throws TorqueException
     */
    public void save(Connection con) throws TorqueException
    {
        if (!alreadyInSave)
      {
        alreadyInSave = true;



  
        // If this object has been modified, then save it to the database.
        if (isModified())
        {
            if (isNew())
            {
                PatientPeer.doInsert((Patient) this, con);
                setNew(false);
            }
            else
            {
                PatientPeer.doUpdate((Patient) this, con);
            }
        }

                                    
                
          if (collOrderings != null)
          {
              for (int i = 0; i < collOrderings.size(); i++)
              {
                  ((Ordering) collOrderings.get(i)).save(con);
              }
          }
                  alreadyInSave = false;
      }
      }


                        
    
    

        /**
     * Set the PrimaryKey using ObjectKey.
     *
     * @param  patient_id ObjectKey
     */
    public void setPrimaryKey(ObjectKey key)
        throws TorqueException
    {
                    setPatientId(((NumberKey) key).intValue());
            }

    /**
     * Set the PrimaryKey using a String.
     *
     * @param key
     */
    public void setPrimaryKey(String key) throws TorqueException
    {
                    setPatientId(Integer.parseInt(key));
            }


    /**
     * returns an id that differentiates this object from others
     * of its class.
     */
    public ObjectKey getPrimaryKey()
    {
        return SimpleKey.keyFor(getPatientId());
    }

 

    /**
     * Makes a copy of this object.
     * It creates a new object filling in the simple attributes.
     * It then fills all the association collections and sets the
     * related objects to isNew=true.
     */
    public Patient copy() throws TorqueException
    {
        return copyInto(new Patient());
    }

    protected Patient copyInto(Patient copyObj) throws TorqueException
    {
        copyObj.setPatientId(patient_id);
        copyObj.setPatientName(patient_name);
        copyObj.setPatientAge(patient_age);
        copyObj.setPatientSex(patient_sex);

                      copyObj.setPatientId(0);
                        

                                  
                
        List v = getOrderings();
        for (int i = 0; i < v.size(); i++)
        {
            Ordering obj = (Ordering) v.get(i);
            copyObj.addOrdering(obj.copy());
        }
              
        return copyObj;
    }

    /**
     * returns a peer instance associated with this om.  Since Peer classes
     * are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     */
    public PatientPeer getPeer()
    {
        return peer;
    }
}
