package jp.co.konica.mg.webdb;

import java.util.*;
import java.text.*;
import org.apache.torque.*;
import org.apache.torque.util.*;

public class OrderManager implements IOrderManager{

  Patient       patient;
  Ordering      order;

  public OrderManager(){
    init();
  }

  private void init(){
    //ɏR[h
  }

  public Vector selectAllOrders(){
    //ɃI[_[Xg̎擾
    try{
      return getOrderingBeans( OrderingPeer.doSelect(new Criteria() ) );
    }catch(TorqueException ex){
      ex.printStackTrace();
      return null;
    }
  }
  public Vector selectAllPatients(){
    //҃Xg̎擾
    try{
      return getPatientBeans( PatientPeer.doSelect(new Criteria()) );
    }catch(TorqueException ex){
      ex.printStackTrace();
      return null;
    }
  }

  public Vector selectOrders(OrderingBean req){
    Criteria criteria = new Criteria();
    if(req!=null) {
      if( req.getId()            !=0  ) criteria.add( OrderingPeer.ORDER_ID,       req.getId()                , Criteria.EQUAL);
      if( req.getPatientId()     !=0  ) criteria.add( OrderingPeer.PATIENT_ID,     req.getPatientId()         , Criteria.EQUAL);
      if( req.getCategory()      !="" ) criteria.add( OrderingPeer.ORDER_CATEGORY, (Object)req.getCategory()  , Criteria.EQUAL);
      if( req.getModality()      !="" ) criteria.add( OrderingPeer.MODALITY,       (Object)req.getModality()  , Criteria.EQUAL);
      if( req.getPart()          !="" ) criteria.add( OrderingPeer.PART,           (Object)req.getPart()      , Criteria.EQUAL);
      if( req.getDirection()     !="" ) criteria.add( OrderingPeer.DIRECTION,      (Object)req.getDirection() , Criteria.EQUAL);
      if( req.getOperationDate() !="" ){
        try{
          criteria.add( OrderingPeer.OPERATIONDATE, new SimpleDateFormat("yyyy/MM/dd").parse( req.getOperationDate() ) , Criteria.EQUAL);
        }catch(ParseException ex){
          //criteriaƂĂ͖
        }
      }
    }
    try{
      return getOrderingBeans( OrderingPeer.doSelect(criteria) );
    }catch(TorqueException ex){
      ex.printStackTrace();
      return null;
    }
  }
  public Vector selectPatients(PatientBean req){
    //Ɋ҂̎擾
    Criteria criteria = new Criteria();
    if(req!=null)
    {
      if(req.getId() !=0  ) criteria.add(PatientPeer.PATIENT_ID  , req.getId()  , Criteria.EQUAL);
      if(req.getAge()!=0  ) criteria.add(PatientPeer.PATIENT_AGE , req.getAge() , Criteria.EQUAL);
      if(req.getSex()!="" ) criteria.add(PatientPeer.PATIENT_SEX , (Object)req.getSex() , Criteria.LIKE);
      if(req.getName()!="") criteria.add(PatientPeer.PATIENT_NAME, (Object)("%"+req.getName()+"%"), Criteria.LIKE);
    }
    try{
      return getPatientBeans( PatientPeer.doSelect(criteria) );
    }catch(TorqueException ex){
      ex.printStackTrace();
      return null;
    }
  }

  /* DAOϊ\bh */

  private Vector getPatientBeans(List patients)
  {
      if(patients==null) return new Vector();
      Iterator itr = patients.iterator();
      Vector patientVector = new Vector();
      {
        while(itr.hasNext()){
          Patient patient = (Patient)itr.next();
          PatientBean patientBean = new PatientBean();
          {
            patientBean.setId  ( patient.getPatientId()   );
            patientBean.setName( patient.getPatientName() );
            patientBean.setAge ( patient.getPatientAge()  );
            patientBean.setSex ( patient.getPatientSex()  );
          }
          patientVector.add(patientBean);
        }
      }
      return patientVector;
  }

  private Vector getOrderingBeans(List orderings)
  {
      if(orderings==null) return new Vector();
      Iterator itr = orderings.iterator();
      Vector orderingVector = new Vector();
      {
        while(itr.hasNext()){
          Ordering ordering = (Ordering)itr.next();
          OrderingBean orderingBean = new OrderingBean();
          {
            orderingBean.setId       ( ordering.getOrderId()       );
            orderingBean.setPatientId( ordering.getPatientId()     );
            orderingBean.setCategory ( ordering.getOrderCategory() );
            orderingBean.setModality ( ordering.getModality()      );
            orderingBean.setPart     ( ordering.getPart()          );
            orderingBean.setDirection( ordering.getDirection()     );
            String dateStr = new SimpleDateFormat("yyyy/MM/dd").format( ordering.getOperationdate() ); 
            orderingBean.setOperationDate ( dateStr );
          }
          orderingVector.add(orderingBean);
        }
      }
      return orderingVector;
  }

}
