package jp.co.konica.mg.webdbclient;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class OrderFrame extends JFrame  {

  JTable patientTable            = new JTable();
  JScrollPane patientScrollPane  = new JScrollPane(patientTable);
  JTable orderingTable           = new JTable();
  JScrollPane orderingScrollPane = new JScrollPane(orderingTable);
  JButton updateButton           = new JButton();
  JLabel  patientsLabel          = new JLabel();
  JLabel  orderingsLabel         = new JLabel();

  IOrderAction orderAction;

  public OrderFrame() {
    try {
      jbInit();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void setOrderAction(IOrderAction action){
    if(action==null) return;
    orderAction = action;
    patientTable.setModel(orderAction.getPatientTableModel());
    orderingTable.setModel(orderAction.getOrderingTableModel());
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(480, 310));
    this.setTitle("OrderManagementSystem");

    patientTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    patientTable.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
          if(e.getClickCount()==2)
          patientTable_mousePerformed(e);
      }
    });
    patientScrollPane.setBounds(new Rectangle(30, 25, 320, 105));

    orderingTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    orderingScrollPane.setBounds(new Rectangle(30, 150, 420, 115));

    updateButton.setText("XV");
    updateButton.setBounds(new Rectangle(380, 25, 60, 35));
    updateButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
          updateButton_actionPerformed(e);
      }
    });

    patientsLabel.setText("҃Xg");
    patientsLabel.setBounds(new Rectangle(35, 5, 100, 15));

    orderingsLabel.setText("I[_[");
    orderingsLabel.setBounds(new Rectangle(35, 130, 110, 20));

    this.getContentPane().add(patientScrollPane,null);
    this.getContentPane().add(orderingScrollPane,null);
    this.getContentPane().add(orderingsLabel, null);
    this.getContentPane().add(patientsLabel, null);
    this.getContentPane().add(updateButton, null);
  }

  void updateButton_actionPerformed(ActionEvent e) {
     if(orderAction==null) return;
     orderAction.updatePatients();
  }
  void patientTable_mousePerformed(MouseEvent e) {
    if(orderAction==null) return;
    orderAction.updateOrderings(patientTable.getSelectedRow());
  }

}