package jp.co.konica.mg.webdbclient;

import jp.co.konica.mg.webdb.*;
import javax.swing.table.*;
import java.util.*;

class PatientTableModel extends AbstractTableModel
{

  private String columnNames[] = {"ID","NAME","AGE","SEX"};
  private Vector patients = new Vector();

  public int getColumnCount()      { return columnNames.length; }
  public int getRowCount()         { return patients.size(); }

  public String getColumnName(int col){ return columnNames[col]; }

  public Object getValueAt(int row,int col)
  {
    PatientBean patient = (PatientBean)patients.get(row);
    switch(col)
    {
      case 0: return new Integer(patient.getId());
      case 1: return patient.getName();
      case 2: return new Integer(patient.getAge());
      case 3: return patient.getSex();
      default: throw new IllegalArgumentException("Invalid column");
    }
  }

  public void setPatientBeans(Vector beans)
  {
    patients = beans;
    fireTableDataChanged();
  }
	
  public int getPatientIdAt(int row)
  {
    if(patients.size()<=row) throw new IllegalArgumentException("Invalid patient selected");
    PatientBean patient = (PatientBean)patients.get(row);
    return patient.getId();
  }

}
